#include "colors.inc"
#include "textures.inc"
#include "finish.inc"
#include "skies.inc"
#include "stones.inc"
#include "waterpump.inc"

background { SkyBlue }
sky_sphere { S_Cloud5 }

//light_source { <0, 150, -300> color White }
//light_source { <0, 100, 0> color White }
light_source { <0, 350, -500> color White }
light_source { <0, 351, -500> color White }
light_source { <0, 352, -500> color White }
light_source { <0, 351, -499> color White }
light_source { <0, 350, -498> color White }
//light_source { 


plane {
    y, 0

texture{
  pigment {color rgb <0.8,0.8,0.85>}
     normal {wrinkles 0.3 scale 2}
        finish {ambient 0.3 diffuse 0.4}
     }
}

camera {
	location <3,4,-10>
    look_at <0, 5, 0>
}

// Ok, start your scene.   

object { waterpump }

// Used from the documentation of Friedrich A.Lohmller.
prism{
	-2.00,
	2.00,
	6,
	<-1.00, 0.00>,
	< 1.00, 0.00>,
	< 1.00, 1.00>,
	< 0.00, 2.00>,
	<-1.00, 1.00>,
	<-1.00, 0.00>
	texture{ 
		pigment{ color rgb <0.1,0.05,0.02> }
	}
	rotate<-90,15,0>
	scale <6,6,6>
	translate <-50,0,75>
}


#declare trees = 1;

#if (trees = 1) 

// Put some trees in the background

#include "leafdefs.inc"
#include "splinetree.inc"

#declare recursionmax = 6; // Defines the complexity of the tree
#declare divisions = array[6] {6,4,4,3,2,2}
init_rand (89,158,157)     // Supply seeds to initialize the random variable

// Variables modeled exponentially
// Use: init_variable (start_size, end_size, base)
init_tdev (0.4, 0.8, 0.9)
init_rdev (70, 40, 1)
init_twigprob (0, 0.7, 0.5)
init_branchl (3.4, 0.2, 0.6)
init_branchw (0.35, 0.005, 0.4)

// Odd variables
init_roots (2)                  // Use: init_roots (rootrecursionmax)
init_splinedev (0.3,0.5)        // Use: init_splinedev (min_dev, max_dev)
init_simplify (2,2)             // Use: init_simplify (num_simplify_levels, num_segments)

// Add some gravity
#declare tendancy = <-0.1,-0.5,0>;

// Assign the branch texture
#declare branchtexture = texture { standard_branch } // standard_branch is defined in leafdefs.inc

///////////////////////////////////////////////////////////////
// Define transformations assigned to the whole tree here.
#declare global_transform = transform {
        scale <1,2,1>
        rotate <0,0,0>
        translate <-3,0.3,30>
}

// Provide feedback in the first 2 recursion levels
#declare feedback = 0;

// Call the macro
splinetree(0,0)


///////////////////////////////////////////////////////////////
// Define transformations assigned to the whole tree here.
#declare global_transform = transform {
        scale <1,1.8,1>
        rotate <0,0,0>
        translate <-15,0.3,12>
}

// Provide feedback in the first 2 recursion levels
#declare feedback = 0;

// Call the macro
splinetree(0,0)

///////////////////////////////////////////////////////////////
// Define transformations assigned to the whole tree here.
#declare global_transform = transform {
        scale <1,1.4,1>
        rotate <0,0,0>
        translate <0,0.3,5>
}

// Provide feedback in the first 2 recursion levels
#declare feedback = 0;

// Call the macro
splinetree(0,0)

///////////////////////////////////////////////////////////////
// Define transformations assigned to the whole tree here.
#declare global_transform = transform {
        scale <1,1.4,1>
        rotate <0,0,0>
        translate <-50,0.3,60>
}

// Provide feedback in the first 2 recursion levels
#declare feedback = 0;

// Call the macro
splinetree(0,0)

#end




